"""Globals pertaining to the Tapis ``files`` API
"""

__all__ = [
    'FILES_API_TYPES', 'FILE_TYPES', 'DIRECTORY_TYPES', 'TYPE_KEY', 'NAME_KEY',
    'PATH_KEY', 'PAGE_SIZE', 'DEFAULT_PEM_GRANTEE', 'DEFAULT_PEM_LEVEL',
    'FILES_PROPERTIES', 'FILE_ANNOTATION', 'DIRECTORY_ANNOTATION',
    'RESOURCE_ANNOTATION', 'ALL_ANNOTATIONS'
]

FILE_TYPES = ('file')
DIRECTORY_TYPES = ('dir')
FILES_API_TYPES = FILE_TYPES + DIRECTORY_TYPES

TYPE_KEY = 'type'
NAME_KEY = 'name'
PATH_KEY = 'path'

PAGE_SIZE = 100

DEFAULT_PEM_GRANTEE = 'world'
DEFAULT_PEM_LEVEL = 'READ'

FILE_ANNOTATION = 'file'
DIRECTORY_ANNOTATION = 'dir'
RESOURCE_ANNOTATION = 'record'

APPS_PROPERTIES = [RESOURCE_ANNOTATION]
FILES_PROPERTIES = [FILE_ANNOTATION, DIRECTORY_ANNOTATION]
SYSTEMS_PROPERTIES = [RESOURCE_ANNOTATION]
JOBS_PROPERTIES = [RESOURCE_ANNOTATION, FILES_PROPERTIES]
METADATA_PROPERTIES = [RESOURCE_ANNOTATION]
NOTIFICATIONS_PROPERTIES = [RESOURCE_ANNOTATION]
ALL_ANNOTATIONS = [FILE_ANNOTATION, DIRECTORY_ANNOTATION, RESOURCE_ANNOTATION]
